unit ServerUnit1;

interface

{ This Project is a perfect starting point for any RTC Web Application.

  Simply customize theo "Server" and "WafServerModule" components and
  their events to make this into your own Server (for example, the
  ModuleFileName property could point to another URI inside your Server).

  See properties and implementations of event on the WafServerModule component for more info. }

uses
  rtcTrashcan,

  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs,

  rtcThrPool, rtcCache, rtcLog,

  rtcWafSrv, rtcFunction, rtcDataSrv,
  rtcSrvModule, rtcInfo, rtcConn, rtcHttpSrv, StdCtrls,

  // This is the unit with our Web Applications Main Form
  TestForm;

type
  TServerForm = class(TForm)
    Server: TRtcHttpServer;
    WafServerModule: TRtcWafServerModule;
    btnListen: TButton;
    Label1: TLabel;
    ePort: TEdit;
    btnStopListen: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnListenClick(Sender: TObject);
    procedure btnStopListenClick(Sender: TObject);
    procedure ServerListenStart(Sender: TRtcConnection);
    procedure ServerListenStop(Sender: TRtcConnection);
    procedure WafServerModuleAppError(const E: Exception);
    procedure WafServerModuleAppStart;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ServerForm: TServerForm;

implementation

{$R *.dfm}

{ TForm2 }

procedure TServerForm.FormCreate(Sender: TObject);
  begin
  LOG_THREAD_EXCEPTIONS:=True;
  LOG_EXCEPTIONS:=True;
  CACHE_FOLDER:='SERVER_CACHE';

  StartLog;
  end;

procedure TServerForm.WafServerModuleAppStart;
  begin
  // Create and Show the Main Application Form
  TWafTestForm.Create(nil).Show;
  // we could also do any other initialization here, if necessary.
  end;

procedure TServerForm.WafServerModuleAppError(const E: Exception);
  begin
  // We could Create and show another Form here
  // when unhandled Exceptions are raised, but
  // since we only have a TRtcForm component to experiment with,
  // we will simply ignore unhandled exceptions.

  {with TErrorForm.Create(nil) do
    begin
    Caption:=E.ClassName;
    eMessage.Caption:=E.Message;
    Show;
    end;}
  end;

procedure TServerForm.btnListenClick(Sender: TObject);
  begin
  Server.ServerPort:=AnsiString(ePort.Text);
  Server.Listen;
  end;

procedure TServerForm.btnStopListenClick(Sender: TObject);
  begin
  Server.StopListen;
  end;

procedure TServerForm.ServerListenStart(Sender: TRtcConnection);
  begin
  if not Sender.inMainThread then
    Sender.Sync(ServerListenStart)
  else
    begin
    btnListen.Enabled:=False;
    btnStopListen.Enabled:=True;
    end;
  end;

procedure TServerForm.ServerListenStop(Sender: TRtcConnection);
  begin
  if not Sender.inMainThread then
    Sender.Sync(ServerListenStop)
  else
    begin
    btnListen.Enabled:=True;
    btnStopListen.Enabled:=False;
    end;
  end;

end.
