unit TestForm;

interface

uses
  Classes, Controls, SysUtils,

  rtcLink, rtcBase, rtcGraphics,
  rtcControls, rtcForms;

{ Since the TRtcForm class is a TWinControl descendant rather than a TForm descendant,
  you will not see the Form Caption in the IDE (it will be visible in the Player) and
  if you with to position the Form, you should manually enter values for Left and Right
  because moving the Form around in the IDE will only move its editor container.
  There is a compiler directive "IDE_Link" which can be declared in the rtcSDK package
  to automatically update Left and Right values when the form is being moved arround
  in the IDE, but since this is a proprietary solution which could cause problems
  in a newer IDE where Windows are "suck" inside a patent form, that directive
  is undeclared by default.

  To create a new Form, you can either (A) make a copy of this Form and start from there,
  or ... select "New Form" from the Delphi menu, then change the "Forms" unit in the
  uses clause into "rtcForms" and the "=class(TForm)" declaration into "=class(TRtcForm)",
  save the unit, close it and reopen it. You should then get some warnings about missing
  properties or events, for which you can simply click "Ignore ALL". After you save the
  unit again, the next time you open it, there will be no more warnings and you will
  have successfully converted an empty TForm into an empty TRtcForm.

  Remember that even though you can drop any non-visual component on the RTC Form,
  you can ONLY use visual components which are prepared for use with the RTC W/A Framework.
  Using visual components which are not made for use with the W/A Framework will still
  create them on the Server, but they will not be visible on the Client side (Player). }

type
  TWafTestForm = class(TRtcForm)
    procedure rtcFormMouseDownMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure rtcFormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rtcFormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure TWafTestForm.rtcFormMouseDownMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  begin
  Caption:='Mouse at:'+IntToStr(X)+','+IntToStr(y);
  end;

procedure TWafTestForm.rtcFormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  begin
  Caption:='Mouse down at:'+IntToStr(X)+','+IntToStr(y);
  end;

procedure TWafTestForm.rtcFormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  begin
  Caption:='Mouse up at:'+IntToStr(X)+','+IntToStr(y);
  end;

end.
