{
  @html(<b>)
  Memory Check Unit
  @html(</b>)
  - Copyright (c) Danijel Tkalcec
  @html(<br><br>)
}

unit rtcMemory;

{$INCLUDE rtcDefs.inc}

{$IFNDEF FPC}
  {$O-}
{$ENDIF}

interface

{ Get Complete Heap Status }
function Get_HeapStatus:THeapStatus;

{ Check the ammount of memoy in use (bytes) }
function Get_MemoryInUse:longint;

{ Check how much Address Space is used by the Application (KB) }
function Get_AddressSpaceUsed: Cardinal;

implementation

uses 
  SysUtils,
{$ifdef Windows}
  Windows;
{$else}
  Unix;
{$endif}

{$ifdef WINDOWS}
function Get_AddressSpaceUsed: Cardinal;
  var
    LMemoryStatus: TMemoryStatus;
  begin
  {Set the structure size}
  LMemoryStatus.dwLength := SizeOf(LMemoryStatus);
  {Get the memory status}
  GlobalMemoryStatus(LMemoryStatus);
  {The result is the total address space less the free address space}
  Result := (LMemoryStatus.dwTotalVirtual - LMemoryStatus.dwAvailVirtual) shr 10;
  end;
{$else}
function Get_AddressSpaceUsed: Cardinal;
  var
    hs :THeapStatus;
  begin
  // no funciton available?
  hs := GetHeapStatus;
  Result := hs.TotalCommitted
  end;
{$endif}

function Get_HeapStatus:THeapStatus;
  begin
  Result:=GetHeapStatus;
  end;

function Get_MemoryInUse:longint;
  begin
  Result:=GetHeapStatus.TotalAllocated;
  end;

end.
