{
  RealThinClient SDK - UNIX support
  Copyright (c) Danijel Tkalcec
  @exclude
}

unit rtcUnixConsoleApp;

// this is CustomApplication unit, designed to support LCL (VCL)
// application usage start

interface

uses
  Classes, SysUtils, CustApp, nixMsgQueue, nixWinMsgQueue;

type
  { TLinuxConsoleApplication }

  TLinuxConsoleApplication = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteHelp; virtual;
  end;


implementation

{ TLinuxConsoleApplication }

procedure TLinuxConsoleApplication.DoRun;
var
  ErrorMsg: String;
begin
  // quick check parameters
  ErrorMsg:=CheckOptions('h','help');
  if ErrorMsg<>'' then begin
    ShowException(Exception.Create(ErrorMsg));
    Halt;
  end;

  // parse parameters
  if HasOption('h','help') then begin
    WriteHelp;
    Halt;
  end;

  winmsgMainLoop;
  { add your program here }

  // stop program loop
  Terminate;
end;

constructor TLinuxConsoleApplication.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor TLinuxConsoleApplication.Destroy;
begin
  inherited Destroy;
end;

procedure TLinuxConsoleApplication.WriteHelp;
begin
  { add your help code here }
//  writeln('Usage: ',ExeName,' -h');
end;


end.

