{
  RealThinClient SDK - UNIX support
  Copyright (c) Danijel Tkalcec
  @exclude
}

unit rtcUnixDebug;

interface

uses
  SysUtils;

procedure DebugLine(const s: string; lvl: byte = 0; Condition: Boolean = true); overload;
procedure DebugLine(const fmt: string; const params: array of const; lvl: byte = 0; Condition: Boolean = true); overload;

var
  DebugLvl : set of byte = [];

function RegisterDebugLVL: byte;
procedure EnableDebugDefault;

implementation

var
  DbgLvl : Byte = 1;

procedure EnableDebugDefault;
begin
  Include(DebugLvl, 0);
end;

function RegisterDebugLVL: byte;
begin
  while (DbgLvl <> 0) and (DbgLvl in DebugLvl) do
    inc(DbgLvl);
  Result := DbgLvl;
  if DbgLvl <> 0 then begin
    Include(DebugLvl, DbgLvl);
    inc(DbgLvl);
  end;
end;

procedure DebugLine(const s: string; lvl: byte; Condition: boolean);
begin
  if not Condition then Exit;
  if lvl in DebugLvl then
    writeln(s);
end;

procedure DebugLine(const fmt: string; const params: array of const; lvl: byte; Condition: boolean); overload;
begin
  DebugLine(Format(fmt, params), lvl, Condition);
end;

end.

