{
  RealThinClient SDK - UNIX support
  Copyright (c) Danijel Tkalcec
  @exclude
}

unit rtcSocketAPI; 

interface

const
  INFINITE = $FFFFFFFF;
  WM_USER = $400;
  
type 
  PServEnt = ^TServEnt;
  servent = packed record
    s_name: PChar;
    s_aliases: ^PChar;
    s_port: Word;
    s_proto: PChar;
  end;
  TServEnt = servent;
  
  PProtoEnt = ^TProtoEnt;
  protoent = packed record
    p_name: PChar;
    p_aliases: ^Pchar;
    p_proto: Smallint;
  end;
  TProtoEnt = protoent;
  
  PHostEnt = ^THostEnt;
  hostent = packed record
    h_name: PChar;
    h_aliases: ^PChar;
    h_addrtype: Smallint;
    h_length: Smallint;
    case Byte of
      0: (h_addr_list: ^PChar);
      1: (h_addr: ^PChar)
  end;
  THostEnt = hostent;
  
  TSocket = Integer;  
  
  SunB = packed record
    s_b1, s_b2, s_b3, s_b4: byte;
  end;
  SunW = packed record
    s_w1, s_w2: word;
  end;

  in_addr = record
    case integer of
      0: (S_un_b: SunB);
      1: (S_un_w: SunW);
      2: (S_addr: LongWord);
  end;

  PInAddr = ^TInAddr;
  TInAddr = in_addr;
  sockaddr_in = packed record
    case Integer of
      0: (sin_family: Word;
          sin_port: Word;
          sin_addr: TInAddr;
          sin_zero: array[0..7] of Char);
      1: (sa_family: Word;
          sa_data: array[0..13] of Char)
  end;

  PSOCKADDR = ^TSockAddr;
  TSockAddrIn = sockaddr_in;
  TSockAddr = sockaddr_in;
  
 
var  
  SetLastSockError : procedure (iError: Integer) = nil; 
  GetLastSockError : function : Integer = nil; 
  GetServByName    : function (name, proto: PChar): PServEnt = nil; 
  GetProtoByName   : function (name: PChar): PProtoEnt = nil;
  GetHostByName    : function (name: PChar): PHostEnt = nil; 
  GetHostByAddr    : function (addr: Pointer; len, Struct: Integer): PHostEnt = nil; 
  GetHostName  : function (name: PChar; len: Integer): Integer = nil;
  OpenSocket   : function (af, Struct, protocol: Integer): TSocket = nil; 
  Shutdown     : function (s: TSocket; how: Integer): Integer = nil; 
  SetSockOpt : function (s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer = nil; 
  GetSockOpt : function (s: TSocket; level, optname: Integer; optval: PChar; var optlen: Integer): Integer = nil; 
  SendTo : function (s: TSocket; const Buf; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer = nil; 
  Send   : function (s: TSocket; var Buf; len, flags: Integer): Integer = nil; 
  Recv     : function (s: TSocket; var Buf; len, flags: Integer): Integer = nil; 
  RecvFrom : function (s: TSocket; var Buf; len, flags: Integer; var from: TSockAddr; var fromlen: Integer): Integer = nil; 
  ntohs        : function (netshort: Word): Word = nil; 
  ntohl        : function (netlong: LongWord): LongWord = nil; 
  Listen       : function (s: TSocket; backlog: Integer): Integer = nil; 
  IoctlSocket  : function (s: TSocket; cmd: DWORD; var arg: LongWord): Integer = nil; 
  Inet_ntoa    : function (inaddr: TInAddr): PChar = nil; 
  Inet_addr    : function (cp: PChar): LongWord = nil; 
  GetSockName  : function (s: TSocket; var name: TSockAddr; var namelen: Integer): Integer = nil;
  GetPeerName  : function (s: TSocket; var name: TSockAddr; var namelen: Integer): Integer = nil;
  Connect      : function (s: TSocket; var name: TSockAddr; namelen: Integer): Integer = nil; 
  CloseSocket  : function (s: TSocket): Integer = nil; 
  Bind         : function (s: TSocket; var addr: TSockAddr; namelen: Integer): Integer = nil; 
  Accept       : function (s: TSocket; addr: PSockAddr; addrlen: PInteger): TSocket = nil; 
  Select       : function (s: TSocket; read_socks, write_socks, except_socks: PInteger; timeOut: Integer): Integer = nil;
  

implementation

end.

