{
  RealThinClient SDK - UNIX support
  Copyright (c) Danijel Tkalcec
  @exclude
}

unit rtcUnixSockets; 

interface

uses
  Classes, SysUtils; 

var  
  SetLastSockError : procedure (iError: Integer) = nil; 
  GetLastSockError : function : Integer; 
  GetServByName    : function (name, proto: PChar): PServEnt; 
  GetProtoByName   : function (name: PChar): PProtoEnt;
  GetHostByName    : function (name: PChar): PHostEnt; 
  GetHostByAddr    : function (addr: Pointer; len, Struct: Integer): PHostEnt; 
  GetHostName      : function (name: PChar; len: Integer): Integer;
  OpenSocket       : function (af, Struct, protocol: Integer): TSocket; 
  Shutdown              = function (s: TSocket; how: Integer): Integer; 
  SetSockOpt            = function (s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer; 
  GetSockOpt            = function (s: TSocket; level, optname: Integer; optval: PChar; var optlen: Integer): Integer; stdcall;
  SendTo                = function (s: TSocket; const Buf; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer; stdcall;
  Send                  = function (s: TSocket; var Buf;
                                       len, flags: Integer): Integer; stdcall;
    TRecv                  = function (s: TSocket;
                                       var Buf;
                                       len, flags: Integer): Integer; stdcall;
    TRecvFrom              = function (s: TSocket;
                                       var Buf; len, flags: Integer;
                                       var from: TSockAddr;
                                       var fromlen: Integer): Integer; stdcall;
    Tntohs                 = function (netshort: u_short): u_short; stdcall;
    Tntohl                 = function (netlong: u_long): u_long; stdcall;
    TListen                = function (s: TSocket;
                                       backlog: Integer): Integer; stdcall;
    TIoctlSocket           = function (s: TSocket; cmd: DWORD;
                                       var arg: u_long): Integer; stdcall;
    TInet_ntoa             = function (inaddr: TInAddr): PChar; stdcall;
    TInet_addr             = function (cp: PChar): u_long; stdcall;
    Thtons                 = function (hostshort: u_short): u_short; stdcall;
    Thtonl                 = function (hostlong: u_long): u_long; stdcall;
    TGetSockName           = function (s: TSocket; var name: TSockAddr;
                                       var namelen: Integer): Integer; stdcall;
    TGetPeerName           = function (s: TSocket; var name: TSockAddr;
                                       var namelen: Integer): Integer; stdcall;
    TConnect               = function (s: TSocket; var name: TSockAddr;
                                       namelen: Integer): Integer; stdcall;
    TCloseSocket           = function (s: TSocket): Integer; stdcall;
    TBind                  = function (s: TSocket; var addr: TSockAddr;
                                       namelen: Integer): Integer; stdcall;
    TAccept                = function (s: TSocket; addr: PSockAddr;
                                       addrlen: PInteger): TSocket; stdcall;
  

implementation

end.

