{
  RealThinClient SDK - UNIX support
  Copyright (c) Danijel Tkalcec
  @exclude
}

unit rtcUnixWinCommon;
// this unit contains common constant and types declarations
// that should be used by all WinAPI emulation modules, to avoid
// type declaration doubling...

// if any additional constant or type is required fill free to add
// declaration here...


interface

uses
{$IFDEF UNIX}
  cthreads,
{$ENDIF}
  Types;

const
  INFINITE = $FFFFFFFF;
  MAXLONG  = $FFFFFFFF;
  S_OK     = $00000000;
  S_FALSE  = $00000001;

  ERROR_INSUFFICIENT_BUFFER = $80;
  
  PM_NOREMOVE = 0;
  PM_REMOVE   = 1;
  
  WM_QUIT     = 18;
  WM_USER     = $400;

  WM_KEYFIRST   = 256;
  WM_KEYLAST    = 264;
  WM_MOUSEFIRST = 512;
  WM_MOUSELAST  = 525;

  WM_TIMER     = 275;
  GWL_USERDATA = -21;

type
  HWND = LongWord;
  HMENU = LongWord;
  THINSTANCE = LongWord;
  TRTLCriticalSection = Integer; //! )
  WPARAM = LongWord;
  LPARAM = LongWord;
  ATOM = Word;
  BOOL     = LongBool;
  FILETIME = Integer;

  TWindowProc = function (ahWnd: HWND; auMsg, awParam, alParam: Longword): LongWord;stdcall;
  TTimerProc = procedure (wnd: HWND; uMsg : LongWord; idEvent: LongWord; dwTime: LongWord); stdcall;
  
  LPTSTR = PAnsiChar;
  PWChar = PWideChar;


  TWndClass = record
    style : LongWord;
    lpfnWndProc   : TWindowProc;
    cbClsExtra    : LongWord;
    cbWndExtra    : LongWord;
    hInstance     : LongWord;
    hIcon         : LongWord;
    hCursor       : LongWord;
    hbrBackground : LongWord;
    lpszMenuName  : PAnsiChar;
    lpszClassName : PAnsiChar;
  end;

  // binary compatible with LMessage
  // LMessages cannot be used directly, because LMessage
  // is part of LCL, while RTC application might not use LCL at all
  // (like FCL only console application or daemon)
  TNixMessage = record
    Msg : Cardinal;
    {$ifdef cpu64}
    UnusedMsg: Cardinal;
    {$endif}
    case Integer of
      0 : (
        WParam: LongWord;
        LParam: LongWord;
        Result: LongWord);
      {/$IFNDEF CPU64}
      // on a 64 bit platform these make no sense
      1 : (
        {$IFDEF FPC_LITTLE_ENDIAN}
        WParamLo: Word;
        WParamHi: Word;
        LParamLo: Word;
        LParamHi: Word;
        ResultLo: Word;
        ResultHi: Word);
        {$ELSE}
        WParamHi: Word;
        WParamLo: Word;
        LParamHi: Word;
        LParamLo: Word;
        ResultHi: Word;
        ResultLo: Word);
        {$ENDIF}
  end;
  TMessage = TNixMessage;

  TMsg = record
    wnd : HWND;
    message : LongWord;
    wParam : LongWord;
    lParam : LongWord;
    time   : LongWord;
    pt     : TPoint;
  end;

  TMsgStruct = TMsg;

implementation

end.

