{ 
  RealThinClient W/A Framework: Register RtcForm and RtcDataModule designers for use inside the IDE
  Copyright (c) Danijel Tkalcec

  @exclude
}
unit rtcWAF_Reg;

interface

{$include rtcDefs.inc}

uses
  Classes, Controls,

  {$ifndef FPC}
  DesignIntf, DesignMenus,
  rtcBase, rtcForms, rtcWafSrv,
  {$endif}

  rtcBaseCli, rtcFormsCli,
  rtcWafCli;

{$ifndef FPC}
type
  TRtcFormDesigner = class(TBaseCustomModule, ICustomModule)
  private
    FRoot: TComponent;

  public
    constructor Create(ARoot: TComponent; const Designer: IDesigner); override;
    class function DesignClass: TComponentClass; override;

    function GetAttributes: TCustomModuleAttributes;
    procedure ExecuteVerb(Index: Integer);

    function GetVerb(Index: Integer): string;
    function GetVerbCount: Integer;

    procedure PrepareItem(Index: Integer; const AItem: IMenuItem);

    procedure Saving;

    procedure ValidateComponent(Component: TComponent);
    function ValidateComponentClass(ComponentClass: TComponentClass): Boolean;

    function Nestable: Boolean;

    property Root:TComponent read FRoot;
    end;
{$endif}

procedure Register;

implementation

procedure Register;
  begin
  RegisterComponents('RTC Client', [TRtcWafClientModule]);

  {$ifndef FPC}
  RegisterComponents('RTC Server', [TRtcWafServerModule]);

  // Register base form and datamodule classes,
  // so we can use Delphi IDE to design TRtcFormC and TRtcDataModuleC
  RegisterCustomModule(TRtcBaseFormC,TrtcFormDesigner);
  RegisterCustomModule(TRtcBaseDataModuleC,TrtcFormDesigner);

  // Register design-time form and data module,
  // so developers can use them normally for writing applications
  RegisterCustomModule(TrtcForm,TrtcFormDesigner);
  RegisterCustomModule(TrtcDataModule,TrtcFormDesigner);
  {$endif}
  end;

{$ifndef FPC}
{ TRtcFormDesigner }

constructor TRtcFormDesigner.Create(ARoot: TComponent; const Designer: IDesigner);
  begin
  inherited;
  FRoot:=ARoot;
  end;

class function TRtcFormDesigner.DesignClass: TComponentClass;
  begin
  Result:=nil;
  end;

procedure TRtcFormDesigner.ExecuteVerb(Index: Integer);
  begin

  end;

function TRtcFormDesigner.GetAttributes: TCustomModuleAttributes;
  begin
  Result:=[];
  end;

function TRtcFormDesigner.GetVerb(Index: Integer): string;
  begin

  end;

function TRtcFormDesigner.GetVerbCount: Integer;
  begin
  Result:=0;
  end;

function TRtcFormDesigner.Nestable: Boolean;
  begin
  Result:=False;
  end;

procedure TRtcFormDesigner.PrepareItem(Index: Integer; const AItem: IMenuItem);
  begin

  end;

procedure TRtcFormDesigner.Saving;
  begin

  end;

procedure TRtcFormDesigner.ValidateComponent(Component: TComponent);
  begin

  end;

function TRtcFormDesigner.ValidateComponentClass(ComponentClass: TComponentClass): Boolean;
  begin
  Result:=True;
  end;
{$endif}

end.
