{ 
  RealThinClient W/A Framework: Client-side DataModule base class
  Copyright (c) Danijel Tkalcec

  @exclude
}
unit rtc_DataModuleX;

{$include rtcDefs.inc}

interface

uses
  rtcTrashcan,
  {$ifdef WINDOWS} Windows, {$endif}

  Classes, Controls, SysUtils, Graphics,
  rtcInfo,

  rtcLink, rtcGraphicsCli, rtcControlsCli;

type
  TRtcDataModuleX=class(TDataModule, IrtcfComponentX)
  protected
    isLoading:boolean;
    
    function _Link(const xName:string; xData:TComponent):boolean; virtual;
    function _Process(const xName:string; xData:TRtcValue):boolean; virtual;
    function _Self:TComponent;
    procedure _Paint(Can:TCanvas);

    procedure _BeginLoad; virtual;
    procedure _EndLoad; virtual;
    function _Loading:boolean;
    end;

implementation

{$ifndef FPC}
  {$R *.dfm}
{$endif}

{ TRtcDataModuleX }

function TrtcDataModuleX._Link(const xName: string; xData: TComponent): boolean;
  begin
  Result:=Rtcf_Link(self,xName,xData);
  end;

function TrtcDataModuleX._Process(const xName: string; xData: TRtcValue): boolean;
  begin
  Result:=Rtcf_ProcessComponent(self,xName,xData);
  end;

function TrtcDataModuleX._Self: TComponent;
  begin
  Result:=self;
  end;

procedure TrtcDataModuleX._Paint(Can: TCanvas);
  begin
  // Nothing to do (no canvas)
  end;

procedure TrtcDataModuleX._BeginLoad;
  var
    a:integer;
  begin
  isLoading:=True;
  for a:=0 to ComponentCount-1 do
    if Supports(Components[a],IrtcfComponentX) then
      (Components[a] as IrtcfComponentX)._BeginLoad;
  end;

procedure TrtcDataModuleX._EndLoad;
  var
    a:integer;
  begin
  isLoading:=False;
  for a:=0 to ComponentCount-1 do
    if Supports(Components[a],IrtcfComponentX) then
      (Components[a] as IrtcfComponentX)._EndLoad;
  end;

function TrtcDataModuleX._Loading: boolean;
  begin
  Result:=isLoading;
  end;

initialization
RegisterClass(TrtcDataModuleX);
finalization
UnRegisterClass(TrtcDataModuleX);
end.
